<?php

/**
 * @file
 * CustomModalController class.
 */

namespace Drupal\menu_twig\Controller;

use Drupal\Core\Ajax\AjaxResponse;
use Drupal\Core\Ajax\OpenModalDialogCommand;
use Drupal\Core\Controller\ControllerBase;

/**
 * Class MenuTwigController.
 */
class MenuTwigController extends ControllerBase {

  public function modal($name) {
    $options = [
      'dialogClass' => 'popup-dialog-class',
      'width' => '40%',
    ];
    $twig = \Drupal::service('twig');
    $item_list = ($name == 'filter') ? $twig->getFilters() : $twig->getFunctions();
    foreach(array_keys($item_list) as $key => $item){
      $data[]= [++$key,$item];
    }
    
    $render = [
      '#theme' => 'table',
       '#header' => ['#ID','name'],
        '#rows' => $data,
      '#wrapper_attributes' => [
        'class' => [
          'wrapper__links__link',
        ],
      ],
    ];
    $response = new AjaxResponse();
    $response->addCommand(new OpenModalDialogCommand(t('List of ' . $name . 's avaiable with twig extensions '), render($render), $options));
    return $response;
  }

}
